#include <iostream>
#include <iomanip>
#include <fstream>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

extern int Np,Nxi;
extern double *p,*x,*w_p,*w_x;

extern double *fcurr;

void print_grid()
{
  for (int i=0;i<Np;i++)
    printf("p=%f w_p=%f\n",p[i],w_p[i]);
  for (int i=0;i<Nxi;i++)
    printf("x=%f w_x=%f\n",x[i],w_x[i]);
}



void set_f(double *f,int i,int j,double val)
{
  if ((i<0)||(i>Np-1))
    printf("Error set_f: i=%i out of bounds\n",i);
  if ((j<0)||(j>Nxi-1))
    printf("Error set_f: j=%i out of bounds\n",j);
  
  f[i*Nxi+j]=val;
}


double get_f(double *f,int i,int j)
{
  if ((i<0)||(i>Np-1))
    printf("Error get_f: i=%i out of bounds\n",i);
  if ((j<0)||(j>Nxi-1))
    printf("Error get_f: j=%i out of bounds\n",j);
  
  return f[i*Nxi+j];
}


void set_sqrA(int n,double *f,int i,int j,double val)
{
  if ((i<0)||(i>n-1))
    printf("Error set_sqrA: i=%i out of bounds\n",i);
  if ((j<0)||(j>n-1))
    printf("Error set_sqrA: j=%i out of bounds\n",j);
  
  f[i*n+j]=val;
}


double get_sqrA(int n,double *f,int i,int j)
{
  if ((i<0)||(i>n-1))
    printf("Error get_sqrA: i=%i out of bounds\n",i);
  if ((j<0)||(j>n-1))
    printf("Error get_sqrA: j=%i out of bounds\n",j);
  
  return f[i*n+j];
}

void add_f(double *f,int i,int j,double val)
{
  if ((i<0)||(i>Np-1))
    printf("Error add_f: i=%i out of bounds\n",i);
  if ((j<0)||(j>Nxi-1))
    printf("Error add_f: j=%i out of bounds\n",j);
  f[i*Nxi+j]=f[i*Nxi+j]+val;
}

void print_f(double *f)
{
  for (int i=0;i<Np;i++)
    for (int j=0;j<Nxi;j++)
      printf("i=%i j=%i f=%f\n",i,j,get_f(f,i,j));
}
